accounts/{accountId}/users/{userId}/products
Returns a list of Forma products the user is associated with in their assigned projects.
Only hub administrators can call this endpoint.
Resource Information
| Method and URI | GET https://developer.api.autodesk.com/construction/admin/v1/accounts/:accountId/users/:userId/products |
| Authentication Context | User context optional |
| Required OAuth Scopes | account:read |
| Data Format | JSON |
Request
Headers
| Authorization* string | Must be Bearer <token>, where <token> is a two-legged access token obtained via a Client Credentials Grant flow, or a three-legged access token obtained via an Authorization Code flow or a Secure Service Account (SSA) flow.
The SSA flow is designed for headless server-to-server operations. While it functions like a two-legged flow (no user interaction), it is classified as three-legged because it preserves user context. |
| Region string | Specifies the region where your request should be routed. If not set, the request is routed automatically, which may result in a slight increase in latency.
Possible values: |
| User-Id string | The ID of a user on whose behalf your request is acting.
Your app has access to all users specified by the administrator in the SaaS integrations UI. Provide this header value to identify the user to be affected by the request. You can use either the user’s Forma ID ( Note that this header is required for hub Admin POST, PATCH, and DELETE endpoints if you want to use a 2-legged authentication context. This header is optional for hub Admin GET endpoints. |
Request
URI Parameters
| accountId string: UUID | The ID of the hub that contains the projects. This corresponds to the hub ID used in the Data Management API, with the “b." prefix removed. For example, b.c8b0c73d-3ae9 becomes c8b0c73d-3ae9. |
| userId string | The ID of the user. To find the ID call GET users. You can use either the Forma ID (id) or the Autodesk ID (autodeskId). |
Request
Query String Parameters
| filter[projectId] array: string: uuid | A list of project IDs. Only results where the user is associated with one or more of the specified projects are returned. |
| filter[key] array: string | Filters the list of products by product key — a machine-readable identifier for a Forma product (such as docs, build, or cost).
You can specify one or more keys to return only those products the user is associated with. Example: Possible values: |
| fields array: string | List of fields to return in the response. Defaults to all fields.
Possible values: |
| sort array: string | The list of fields to sort by.
Each property can be followed by a direction modifier of either Possible values: Default is the order in database. |
| limit int | The maximum number of records to return in the response.
Default: Minimum: Maximum: |
| offset int | The index of the first record to return.
Used for pagination in combination with the Example: |
Response
HTTP Status Code Summary
| 200 OK | A list of products associated with the user |
| 400 Bad Request | The request could not be understood by the server due to malformed syntax. |
| 401 Unauthorized | Request has not been applied because it lacks valid authentication credentials for the target resource. |
| 403 Forbidden | The server understood the request but refuses to authorize it. |
| 404 Not Found | The resource could not be found. |
| 406 Not Acceptable | The server cannot produce a response matching the list of acceptable values defined in the request. |
| 410 | Access to the target resource is no longer available. |
| 429 Too Many Requests | User has sent too many requests in a given amount of time. |
| 500 Internal Server Error | An unexpected error occurred on the server. |
| 503 Service Unavailable | Server is not ready to handle the request. |
Response
Body Structure (200)
| pagination object | Contains pagination details for the records returned by the endpoint. |
| limit int | The maximum number of records returned per page. The last page may contain fewer records than the specified limit. |
| offset int | The index of the first record in the returned page. Used for pagination. |
| totalResults int | The total number of records matching the request. |
| nextUrl string | The URL for the next page of records, if more results are available. Max length: 2000 characters.
Max length: 2000 |
| previousUrl string | The URL for the previous page of records, if applicable. Max length: 2000 characters.
Max length: 2000 |
| results array: object | A list of Forma products the user is associated with. |
| key enum:string | A machine-readable identifier for the product (e.g., docs, build).
Each product has a unique key used throughout the API for identification, filtering, and integration logic (e.g., in query parameters like Possible values:
Forma - BIM 360 - Note that this endpoint returns only Forma products. Other endpoints, such as GET projects and GET projects/:projectId, may return both Forma and BIM 360 projects. In those responses, product keys may include BIM 360 values. |
| icon string | The URL of the icon associated with the product. |
| name string | The name of the product. |
| projectIds array: string | The list of projects IDs where the user is associated with the product. |
Example
A list of products associated with the user
Request
curl -v 'https://developer.api.autodesk.com/construction/admin/v1/accounts/d73fc742-4538-401c-8d0f-853b49b750b2/users/6cc15635-2fbd-4f73-afbe-abd833408a1d/products?filter[projectId]=39712a51-bd64-446a-9c72-48c4e43d0a0d,d1163421-e7eb-4862-ac15-b33777ba42de&filter[key]=build,docs&fields=name&sort=name&limit=20' \
-H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
Response
{
"pagination": {
"limit": 20,
"offset": 10,
"totalResults": 121,
"nextUrl": "https://resource?limit=20&offset=30",
"previousUrl": "https://resource?limit=20&offset=0"
},
"results": [
{
"key": "assets",
"icon": "https://s3.us-east-1.amazonaws.com/product_icon.png",
"name": "Document Management",
"projectIds": [
"3e354e66-ac8b-41dd-9bc1-93fc182c25dd"
]
}
]
}